using System.Diagnostics;

namespace MediatorDesignDemo
{
    public class ChatClient
    {
        public delegate void SendMessageNotificationHandler(object sender, string message);
        public event SendMessageNotificationHandler SendMessageNotification;

        public ChatClient(string clientName)
        {
            ClientName = clientName;
        }

        public void AcceptNewMessage(ChatClient fromChatClient, string message)
        {
            Debug.WriteLine(string.Format("[Sent to {0}] FROM {1}: {2}", ClientName,
                fromChatClient.ClientName, message));
        }

        public string ClientName { get; private set; }

        public void SendNewMessage(string message)
        {
            if (SendMessageNotification != null)
            {
                SendMessageNotification(this, message);
            }
        }
    }
}