﻿using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;

namespace MediatorDesignDemo
{
    [TestFixture]
    public class TestHarness
    {
        [Test]
        public void ChatTest()
        {
            var client1 = new ChatClient("Harvey");
            var client2 = new ChatClient("Gorden");
            var chatMediator = new ChatMediator(client1, client2);

            client1.SendNewMessage("Hello Gorden, how are you today");

            client2.SendNewMessage("Harvey, i am doing well.");

            var percyClient = new ChatClient("Percy");
            chatMediator.JoinConversation(percyClient);

            percyClient.SendNewMessage("Hey guys, thought i would say hello");

            chatMediator.LeaveConversation(client2);

            client1.SendNewMessage("Hey, did Gorden just leave????");
        }
    }
}
